/**************************
	AJAX Library
	By Neo101
	Version 1.0.0
**************************/

var ajaxLib = {

	connectionArray : new Array(),
	numberOfConnections : 0,

	callDaemon: function(number){
		return function(){ ajaxLib.onreadystatechange(number) }
	},
	
	openConnection : function(url, method, callBack, postData){
		var object = this.getActiveXObject("Microsoft.XMLHTTP")
		if(object == null){
			return
		}
		object.open(method, url, true)
		object.onreadystatechange = this.callDaemon(this.numberOfConnections)
		
		
		this.connectionArray[this.numberOfConnections] = {'object' : object, 'data': postData, 'callBack': callBack}
		this.numberOfConnections += 1
		
	
		return this.numberOfConnections - 1;
	},
	
	setHeader: function( number , headerName, headerData){
		this.connectionArray[number].object.setRequestHeader(headerName, headerData)
	},
	
	onreadystatechange: function( number ){
		if(ajaxLib.connectionArray[number].object.readyState != 4){
			return
		}
		if(ajaxLib.connectionArray[number].object.status != 200 && ajaxLib.connectionArray[number].object.status != 201){
			ajaxLib.connectionArray[number].callBack.onFailure(ajaxLib.connectionArray[number])
		} else {
			ajaxLib.connectionArray[number].callBack.onSuccess(ajaxLib.connectionArray[number].object.responseText, 
				ajaxLib.connectionArray[number])
		}
		
	},
	
	
	makeCall : function( number ){
		ajaxLib.connectionArray[number].object.send( ajaxLib.connectionArray[number].data )
	},

	
	getActiveXObject : function(objectName){
		try{
			var object = external.max_activex(SECURITY_ID, objectName)
		}
		catch(err){
			try{
				var object = new ActiveXObject(objectName)
			}
			catch(err){
				MaxLib.showError('Could not load ActiveX object ' + objectName)
				return null
			}
		}
		return object
	},
	
	clear : function( number ){ // don't know if it's really useful or not, but this should delete the ActiveX object, to save memory
		ajaxLib.connectionArray[number].object = null
		ajaxLib.connectionArray[number] = null
	}

}