/**************************
	Google Spreadsheets
	By Neo101
	Version 1.0.1
**************************/


var gData = {

loginCalled : false,
authURL : 'https://www.google.com/accounts/ClientLogin',


viewFeeds : function(){
	this.viewLatestSpreadsheets()
},


/****************** Login **********************/


login : function(){
	var url = this.authURL + '?Email='+settings.emailAddress+'&Passwd='+settings.password+'&source=Maxthon-GoogleSpreadsheets-1.01&service=wise'
	
	var callBack = {'onFailure': this.onFailure, 'onSuccess': this.onResponseLogin}
	
	var number = ajaxLib.openConnection(url, 'get', callBack, null)
	
	ajaxLib.makeCall( number )
},

onResponseLogin : function(text, object){
	try{
		text = text.split('\n')
	} catch(err){
		MaxLib.showError('Error 266: login response error. Response: ' + text)
	}
	settings.authKey = text[2].substring(5,999)
	MaxLib.writeSetting('authKey', encodeTxt(settings.authKey))
	gData.viewFeeds()
},


/****************** View Events **********************/


viewLatestSpreadsheets : function(){
	var feedURL = 'http://spreadsheets.google.com/feeds/spreadsheets/private/full?max-results=' + settings.maxNumberOfSpreadsheets
	
	var callBack = {'onFailure': this.onFailure, 'onSuccess': this.onResponseView}
	
	var number = ajaxLib.openConnection(feedURL, 'get', callBack, null)
	ajaxLib.setHeader( number, "Authorization", "GoogleLogin auth="+settings.authKey)
	ajaxLib.makeCall( number )
},



onResponseView : function(responseText, object){
	var objXMLDOM = new ActiveXObject("Microsoft.XMLDOM")
	objXMLDOM.async = false 
	
	objXMLDOM.loadXML(responseText) 
	var responseXML = objXMLDOM.documentElement 
	
	//var win = window.open()
	//win.document.write('<xmp>' + responseText + '</xmp>')
	//return

	if(responseXML == null){
		MaxLib.showError('Error 318: Could not parse feed')
		return
	}
	
	var spreadsheetsArray = new Array()
	items = responseXML.getElementsByTagName("entry")
	
	if(items && items.length != 0){
		for(var j=0; j < items.length; j++) {
			gData.addFeedItem(items[j], spreadsheetsArray)
		}
	}
	
	createSpreadsheetsHtml(spreadsheetsArray)
},



addFeedItem : function(xml , array){
	var item = {}
	item.updated = xml.selectSingleNode("updated").text
	item.title = xml.selectSingleNode("title[@type='text']").text
	item.link = xml.selectSingleNode("link[@rel='alternate' and @type='text/html']/@href").text
	item.detailsUrl = xml.selectSingleNode("link[@rel='self' and @type='application/atom+xml']/@href").text
	
	
	//fix for google spreadsheets problem. item.link = invalid...
	var id = item.detailsUrl.replace(/.*\//,'')
	item.link = item.link.replace(/key=.*/,'key=' + id)
	//end fix
	
	array.push( item )
},



onFailure: function(object){
	if(object.object.status == 401 || object.object.status == 403){
		if(gData.loginCalled == false){
			gData.loginCalled = true
			gData.login()
		} else {
			var message = 'Access denied error...'
			document.getElementById('spreadsheets').innerHTML = message
			MaxLib.showError('Could not login. Please check your account settings')
		}
	}
	else if(object.object.status == 400){
		MaxLib.showError('Error 400: Bad request<br />' + object.object.responseText)
	}
	else{
		if(gData.loginCalled == false && object.object.getResponseHeader("WWW-authenticate") != ''){
			gData.loginCalled = true
			gData.login()
		} else {
			MaxLib.showError('Connection error ' + object.object.status + ' ' + object.object.statusText);
		}
	}
	
	//alert(object.object.responseText) //debug
}

}